<?php declare( strict_types=1 );

namespace FernleafSystems\Wordpress\Plugin\Shield\Tables\DataTables\Build\Scans;

use FernleafSystems\Wordpress\Plugin\Shield\Scans;

class ForMalware extends BaseForScan {

	protected function getColumnsToDisplay() :array {
		return [
			'rid',
			'file_as_href',
			'status',
			'mal_fp_confidence',
			'line_numbers',
			'mal_sig',
			'mal_details',
			'detected',
			'actions',
		];
	}

	protected function getColumnDefs() :array {
		$colDefs = parent::getColumnDefs();
		$colDefs[ 'mal_fp_confidence' ] = [
			'data'       => 'mal_fp_confidence',
			'title'      => __( 'False Positive Confidence' ),
			'className'  => 'mal_fp_confidence',
			'orderable'  => true,
			'searchable' => false,
			'visible'    => false,
		];
		$colDefs[ 'line_numbers' ] = [
			'data'       => 'line_numbers',
			'title'      => __( 'Line Numbers' ),
			'className'  => 'line_numbers',
			'orderable'  => false,
			'searchable' => false,
			'visible'    => false,
		];
		$colDefs[ 'mal_sig' ] = [
			'data'       => 'mal_sig',
			'title'      => __( 'Pattern Detected' ),
			'className'  => 'mal_sig',
			'orderable'  => false,
			'searchable' => false,
			'visible'    => false,
			'searchPanes' => [
				'show' => false
			],
		];
		$colDefs[ 'mal_details' ] = [
			'data'       => 'mal_details',
			'title'      => __( 'Malware Details' ),
			'className'  => 'mal_details',
			'orderable'  => false,
			'searchable' => false,
			'visible'    => true,
		];
		return $colDefs;
	}
}